package ru.dbotthepony.mc.otm.registry

import net.minecraft.resources.ResourceLocation
import net.minecraft.world.item.CreativeModeTab
import net.minecraft.world.item.ItemStack
import net.minecraftforge.event.CreativeModeTabEvent
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.core.util.CreativeMenuComparator
import ru.dbotthepony.mc.otm.core.TranslatableComponent
import ru.dbotthepony.mc.otm.core.util.WriteOnce
import ru.dbotthepony.mc.otm.registry.MItems.BATTERY_CREATIVE

object MCreativeTabs {
	var MAIN by WriteOnce<CreativeModeTab>()
		private set
	var DECORATIVE by WriteOnce<CreativeModeTab>()
		private set

	fun register(event: CreativeModeTabEvent.Register) {
		CreativeMenuComparator.invalidate()

		MAIN = event.registerCreativeModeTab(ResourceLocation(OverdriveThatMatters.MOD_ID, "main")) {
			it.icon { ItemStack(BATTERY_CREATIVE, 1) }
			it.title(TranslatableComponent("itemGroup.otm"))

			it.displayItems { features, consumer, flag ->
				addMainCreativeTabItems(consumer)
			}
		}

		DECORATIVE = event.registerCreativeModeTab(ResourceLocation(OverdriveThatMatters.MOD_ID, "decorative")) {
			it.icon { ItemStack(MRegistry.VENT.item, 1) }
			it.title(TranslatableComponent("itemGroup.otm_decorative"))

			it.displayItems { features, consumer, flag ->
				addDecorativeTabItems(consumer)
			}
		}
	}
}
